/*
*  Rubrica
*  file: file.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_DICT_H
#define _RUBRICA_DICT_H

#include <gnome.h>
#include <gconf/gconf-client.h>

typedef enum {
  ITALIAN = 0,
  ENGLISH,
  OTHER, 
  UNKNOWN
} LANG;

/*
  eliminare TCODE ?? 
*/
typedef enum {
  ADDRESS = 0, CARD, MODIFYING, DELETING, PERSONAL_DATA, FIRST_NAME, 
  LAST_NAME, PROFESSION, STREET, STREET_NUMBER, ZIP_CODE, 
  CITY, PROVINCE, COUNTRY, WEB_ADDRESS, WEB, EMAIL_ADDRESS, EMAIL, 
  TELEPHONE_NUMBERS, TELEPHONE, TYPE, PUBLIC_KEY, NOTE, NO_CODE,  
  END
} TCODE;


typedef struct _rubrica_dic {
  TCODE  code;
  gchar *itstr;
  gchar *enstr;
  gchar *trans;
} RubricaDictionary;

typedef struct _dictionary {
  gchar *address;
  gchar *card;
  gchar *modifying;
  gchar *deleting;
  gchar *data;
  gchar *firstname;
  gchar *middlename;
  gchar *lastname;
  gchar *profession;
  gchar *street;
  gchar *streetnumber;
  gchar *zipcode;
  gchar *city;
  gchar *province;
  gchar *country;
  gchar *webaddresses;
  gchar *web;
  gchar *mailaddresses;
  gchar *mail;
  gchar *tellist;
  gchar *telnum;
  gchar *teltype;
  gchar *pubkey;
  gchar *note;
  gchar *lastchange;
} Dictionary;

void rubrica_dictionary_init(GConfClient *client);
void rubrica_dictionary_load_translation(void);

void rubrica_dictionary_get_italian(void);
void rubrica_dictionary_get_english(void);
void rubrica_dictionary_get_other(void);

void rubrica_dictionary_clean(void);
void rubrica_dictionary_write(gchar *src, gchar **dest);

Dictionary rubrica_dictionary_get_dictionary(gchar*);
void rubrica_dictionary_store_dictionary(Dictionary dict);

gboolean rubrica_dictionary_load_user_dictionary(GConfClient* client, 
						 gchar *dictionary,
						 gchar *language);
void rubrica_dictionary_parse_node(GConfClient* client, 
				   xmlNodePtr node);
gboolean rubrica_dictionary_save_user_dictionary(GConfClient *client, 
						 gchar *dictionary, 
						 gchar *language);

void rubrica_dictionary_extract_user_dictionary(Dictionary *dict, gpointer pbox);
void rubrica_dictionary_display_user_dictionary(gpointer user_data);

#endif
